$regfile = "ATtiny85.DAT"

$crystal = 8000000

Config Portb.0 = Output                                     ' 
Config Portb.1 = Output                                     '
Config Portb.2 = Input : Portb.2 = 1                        '  ,  Pull-Up 
Config Portb.4 = Input : Portb.4 = 1                        ' 
Config Timer0 = Pwm , Prescale = 1 , Compare A Pwm = Clear Down
Config Timer1 = Timer , Prescale = 2048
Config Int0 = Rising                                        '    
Enable Timer1
Enable Int0
On Int0 Reset_timer
On Timer1 Fan_error

Config Adc = Single , Prescaler = Auto , Reference = Internal_1.1

Config Watchdog = 1024                                      'Watchdog   1 

Dim Offset As Word
Dim Temperature As Word
Dim Temp As Word
Dim N As Byte
Dim F_error As Bit : F_error = 0
'*******************************************************************************
Start Watchdog
Enable Interrupts

If Mcusr.wdrf = 0 Then                                      '     Watchdog, 
   Ocr0a = 255                                              '   
   Waitms 500                                               '  
End If

Do

Temp = Getadc(2)                                            '   
   If Temp < 1020 Then                                      ' 
      Temp = Temp / 34
      Offset = 277 + Temp
   Else
      Offset = 292                                          '  
   End If

Temperature = 0                                             '   
   For N = 1 To 16
      Temp = Getadc(15)
      Temperature = Temperature + Temp
   Next N
Temperature = Temperature / 16

If Temperature > Offset Then
   Temperature = Temperature - Offset                       ' 
Else
   Temperature = 8
End If

Temperature = Temperature * 9                               ' 
   If Temperature > 255 Then
         If Temperature > 300 Then Gosub Alarm              ' 50 
      Temperature = 255
   End If

If Temperature < 76 Then Temperature = 76                   '  

If Ocr0a < Temperature Then Incr Ocr0a                      '  
If Ocr0a > Temperature Then Decr Ocr0a

If F_error = 1 Then                                         ' 
   Ocr0a = 255                                              '  
   Gosub Alarm1                                             '  
End If

Waitms 75                                                   ' 

Reset Watchdog

Loop
'-------------------------------------------------------------------------------
Alarm:                                                      ' 
Sound Portb.1 , 200 , 483
Sound Portb.1 , 150 , 758
Return
'-------------------------------------------------------------------------------
Alarm1:                                                     '  
Sound Portb.1 , 65 , 1274
Return
'-------------------------------------------------------------------------------
Reset_timer:                                                '  
Timer1 = 0
F_error = 0
Return
'-------------------------------------------------------------------------------
Fan_error:                                                  '  -   
F_error = 1
Return

End